﻿// Simple class to represent a bouncing ball.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Drawing;

namespace BouncingBallsWindowsForms
{
    class Ball
    {
        private double x = 0.0;
        private double y = 0.0;
        private double r = 0.0;
        private double velocityX = 0.0;
        private double velocityY = 0.0;

        private Random rand = new Random();

        public Ball(double x, double y, double r)
        {
            this.x = x;
            this.y = y;
            this.r = r;

            this.velocityX = (0.5 - rand.NextDouble()) * 5.0;
            this.velocityY = (0.5 - rand.NextDouble()) * 5.0;
        }

        // Update the position of the ball based on its velocity.
        // Invert the velocity if we hit the wall of our bounding canvas.
        public void updatePosition(double maxX, double maxY)
        {
            x += velocityX;
            y += velocityY;

            if ((x <= r) || (x >= maxX - r))
                velocityX *= -1;
            if ((y <= r) || (y >= maxY - r))
                velocityY *= -1;

        }

        public void draw(Graphics g)
        {
            Rectangle rect = new Rectangle((int) (x - r), (int) (y - r), (int) (r * 2), (int) (r * 2.0));
            g.FillEllipse(Brushes.Red, rect);
        }

    }
}
